hdu 5289 关于线段树的解法 很有意思

欢迎参加——BestCoder周年纪念赛(高质量题目+多重奖励)

Assignment

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)

Total Submission(s): 1565    Accepted Submission(s): 754

Problem Description

Tom owns a company and he is the boss. There are n staffs which are numbered from 1 to n in this company, and every staff has a ability. Now, Tom is going to assign a special task to some staffs who were in the same group. In a group, the difference of the
ability of any two staff is less than k, and their numbers are continuous. Tom want to know the number of groups like this.

Input

In the first line a number T indicates the number of test cases. Then for each case the first line contain 2 numbers n, k (1<=n<=100000, 0<k<=10^9),indicate the company has n persons, k means the maximum difference between abilities of staff in a group is less
than k. The second line contains n integers:a[1],a[2],…,a[n](0<=a[i]<=10^9),indicate the i-th staff’s ability.

Output

For each test,output the number of groups.

Sample Input

2
4 2
3 1 2 4
10 5
0 3 4 5 2 1 6 7 8 9

Sample Output

5
28

Hint

First Sample, the satisfied groups include:[1,1]、[2,2]、[3,3]、[4,4] 、[2,3] 

Author

FZUACM

Source

2015 Multi-University Training Contest 1

Recommend

We have carefully selected several similar problems for you:  5309 5308 5307 5306 5305 

题解: 以数组d[i]表示区间以a[i]结尾满足任意两元素差值小于k的最大长度,

则使用线段树查询在a[i]之前与其差值大于等于k的位置为p

d[i] = max(d[i-1],  p+1);

答案即为 sum = 西格玛(d[i] - i + 1);

题目很简单,关键是思路要精确 , 很多时候如果数学思维卡住了,可以使用编程思维来进行解决. 还是很喜欢使用线段树进行解题,多加努力。

#include <cstdio>
#include <algorithm>
#include <cstring>
#include <iostream>

using namespace std;
#define maxn 100000 + 10
#define lson L, mid, rt<<1
#define rson mid+1, R, rt<<1|1

int n, k;
int a[maxn];
int ans;

struct Node
{
    int mi, ma;
}T[maxn<<2];

void pushup(int rt)
{
    int l = rt<<1, r = rt<<1|1;
    T[rt].ma = max(T[l].ma, T[r].ma);
    T[rt].mi = min(T[l].mi, T[r].mi);
}

void build(int L, int R, int rt)
{
    if(L == R)
    {
        T[rt].ma = T[rt].mi = a[L];
        return ;
    }
    int mid = (L + R) >> 1;
    build(lson);
    build(rson);
    pushup(rt);
}

///注意树的节点与区间节点不要混淆
void query(int l, int r, int v, int L, int R, int rt)
{
    if(L == R)
    {
        if(abs(T[rt].mi - v) >= k)
        {
            if(ans == -1 || ans < L)
                ans = L;
        }
        return ;
    }
    int mid = (L + R) >> 1;
    if(r > mid)
        if(abs(T[rt<<1|1].mi - v) >= k || abs(T[rt<<1|1].ma - v) >= k)
        query(l, r, v, rson);
    if(ans == -1 && l <= mid)
        if(abs(T[rt<<1].mi - v) >= k || abs(T[rt<<1].ma - v) >= k)
        query(l, r, v, lson);
}

int d[maxn];
long long sum;

int main()
{
    int t;
    scanf("%d", &t);
    while(t--)
    {
        sum = 1;
        scanf("%d%d", &n, &k);
        for(int i=1; i<=n; i++)
            scanf("%d", &a[i]);
        build(1, n, 1);

        d[1] = 1;
        for(int i=2; i<=n; i++)
        {
            ans = -1;
            query(1, i, a[i], 1, n, 1);
            if(ans == -1)
               d[i] = d[i-1];
            else d[i] = max(d[i-1], ans + 1);
            sum += i - d[i] + 1;
        }
        printf("%I64d\n", sum);
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-07-30 07:38:29

hdu 5289 关于线段树的解法 很有意思的相关文章

ACM学习历程—HDU 5289 Assignment(线段树)

Problem Description Tom owns a company and he is the boss. There are n staffs which are numbered from 1 to n in this company, and every staff has a ability. Now, Tom is going to assign a special task to some staffs who were in the same group. In a gr

HDU 5289 思路+线段树处理

给出N个数,和K 求这N个数的所有满足条件(最大数-最小数<k)的区间个数 数组b记录以当前位置开始,到最右端最多满足条件的数的个数,b数组的值可通过二分+线段树查找区间最大最小值得到 对于第二组数据 10 5 0 3 4 5 2 1 6 7 8 9 B数组为 3 7 7 7 3 1 4 3 2 1 由于当前I点取最右端值可能会导致i+1点和后面取到的点不满足条件,所有应有:b[i]<=b[i+1]+1 得B数组 3 5 4 3 2 1 4 3 2 1 ans=28 #include &quo

POJ 1177/HDU 1828 picture 线段树+离散化+扫描线 轮廓周长计算

求n个图矩形放下来,有的重合有些重合一部分有些没重合,求最后总的不规则图型的轮廓长度. 我的做法是对x进行一遍扫描线,再对y做一遍同样的扫描线,相加即可.因为最后的轮廓必定是由不重合的线段长度组成的,这样理论上是对的 要注意处理高度相同的线段,把底边优先处理(在代码里就是f标记为1的线段),因为若是一个矩形的底边和另一个矩形的上边重合,则这个轮廓肯定不能算 不过POJ和HDU的数据好像都比较弱,我没进行上面的细节处理也AC了,不过一个很简单的数据就会不对,所以还是要处理一下才是真正正确的代码 我

hdu 1542 Atlantis(线段树&amp;扫描线&amp;面积并)

Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6386    Accepted Submission(s): 2814 Problem Description There are several ancient Greek texts that contain descriptions of the fabled i

hdu 1828 Picture(线段树&amp;扫描线&amp;周长并)

Picture Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2578    Accepted Submission(s): 1363 Problem Description A number of rectangular posters, photographs and other pictures of the same shap

HDU 1542 Atlantis 线段树+离散化+扫描线

题意:给出一些矩形的最上角坐标和右下角坐标,求这些矩形的面积并. NotOnlySuccess 线段树专辑中扫描线模板题,弱智的我对着大大的代码看了一下午才搞懂. 具体见思路见注释=.= #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #define lson rt<<1,l,mid #define rson rt<<1|1,mid

HDU 1828 Picture 线段树+扫描线

题意:给你一些矩形的左上角点的坐标和右下角点的坐标,求周长并 最显而易见的思路就是对于x轴和y轴做两次扫描线,对于负数的坐标进行离散化.每次增加的值是线段变化量的绝对值.具体写法和求面积并的差不多. #include <cstdio> #include <algorithm> #include <cstring> #include <vector> using namespace std; #define lson rt << 1 , l , m

HDU 1542 Atlantis(线段树扫描线)

http://acm.hdu.edu.cn/showproblem.php?pid=1542 Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6788    Accepted Submission(s): 2970 Problem Description There are several ancient Greek

hdu 1542 Atlantis(线段树)

Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6899    Accepted Submission(s): 3022 Problem Description There are several ancient Greek texts that contain descriptions of the fabled i